<?php

/**

 *
 * @package    nomina
 * @author     Manuel Enrique Paredes Lopez
 * @email mparedes@sofhouse.net
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class no_cargo_convocatoriaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'NO_CARGO_CONVOCATORIA',
        'NO_NOMBRAMIENTO',
        'NO_NOVEDAD_PERSONAL',
        'NO_NOVEDADES',
        'NO_TIPO_MODALIDAD',
        'RH_DP',
        'RH_SA_NIV2'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'NO_NOMBRAMIENTO,LEFT' =>
        array(
            'id_nombramiento' => 'NO_CARGO_CONVOCATORIA'
        ),
        'NO_NOVEDAD_PERSONAL,LEFT' =>
        array(
            'id_novedad_personal' => 'NO_CARGO_CONVOCATORIA'
        ),
        'NO_NOVEDADES,LEFT' =>
        array(
            'id_novedad' => 'NO_NOVEDAD_PERSONAL'
        ),
        'NO_TIPO_MODALIDAD,LEFT' =>
        array(
            'id_tipo_modalidad' => 'NO_CARGO_CONVOCATORIA'
        ),
        'RH_DP,LEFT' =>
        array(
            'id_dp' => 'NO_CARGO_CONVOCATORIA'
        ),
        'RH_SA_NIV2,LEFT' =>
        array(
            'id_sa_niv2' => 'NO_NOMBRAMIENTO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'NO_CARGO_CONVOCATORIA' =>
        array(
            'id_cargo_convocatoria' => 'id_cargo_convocatoria',
            'id_dp' => 'id_dp',
            'no_opec' => 'no_opec',
            'fecha_convocatoria' => 'fecha_convocatoria',
            'id_tipo_modalidad' => 'id_tipo_modalidad',
            'estado' => 'estado',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log',
            'id_nombramiento' => 'id_nombramiento',
            'id_novedad_personal' => 'id_novedad_personal',
            'fecha_anu' => 'fecha_anu',
            'usuario_anu' => 'usuario_anu',
        ),
        'NO_NOMBRAMIENTO' =>
        array(
            'contrato' => 'contrato',
        ),
        'NO_NOVEDADES' =>
        array(
            'descripcion' => 'descripcion_novedad',
        ),
        'NO_TIPO_MODALIDAD' =>
        array(
            'descripcion' => 'tipo_modalidad',
        ),
        'RH_DP' =>
        array(
            'codigo' => 'codigo',
        ),
        'RH_SA_NIV2' =>
        array(
            'nombre' => 'descripcion_nombramiento',
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'NO_CARGO_CONVOCATORIA' => array(
            'id_cargo_convocatoria,a' => array('!=' => array(-1)),
            'id_cargo_convocatoria,b' => array('=' => array('id_cargo_convocatoria')),
            'id_dp' => array('=' => array('id_dp')),
            'no_opec' => array('LIKEALLPLUS' => array('no_opec')),
            'fecha_convocatoria' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'id_tipo_modalidad' => array('=' => array('id_tipo_modalidad')),
            'id_nombramiento' => array('=' => array('id_nombramiento')),
            'id_novedad_personal' => array('=' => array('id_novedad_personal')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    protected $fields_orderBy = array(
        'codigo', 'estado desc', 'fecha_convocatoria desc', 'id_cargo_convocatoria desc'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_cargo_convocatoria'; //identificador de la tabla
    protected $id_names = array('id_cargo_convocatoria'); //llave primaria
    protected $field_names = array('id_cargo_convocatoria', 'id_dp', 'no_opec', 'fecha_convocatoria',
        'id_tipo_modalidad', 'estado', 'fecha_log', 'usuario_log', 'id_nombramiento',
        'id_novedad_personal', 'fecha_anu', 'usuario_anu'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'NO_CARGO_CONVOCATORIA'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_cargo_convocatoria'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        $logger = sfContext::getInstance()->getLogger();
        //valor por defecto
        $errors = null;

        $logger->info("Entro a validateAdd");

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['usuario_log'] = $request['username'];
            $request['fecha_log'] = CN_TABLE::fechaSistema();
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            $request['usuario_anu'] = $request['username'];
            $request['fecha_anu'] = CN_TABLE::fechaSistema();
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */

        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                $id_cargo_convocatoria = $list_data_post[0]['id_cargo_convocatoria'];
                $id_dp = $request['id_dp'];
                $usuario = $request['username'];

                $sql = <<<EOD
update rh_dp set id_cargo_convocatoria = $id_cargo_convocatoria where id_dp = $id_dp
EOD;
                $this->conn->execute($sql);

                $sql = <<<EOD
update no_cargo_convocatoria set estado = 0, fecha_anu = trunc(sysdate), usuario_anu = '$usuario' 
    where id_dp = $id_dp and id_cargo_convocatoria != $id_cargo_convocatoria and estado = 1
EOD;
                $this->conn->execute($sql);

                //COMMIT DE TODAS LAS TRANSACCIONES
                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    public function executeRemove(sfWebRequest $request) {



        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a executeDelete");

        /*
         * Manejar Errores
         */
        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();

        try {


            $id_cargo_convocatoria = $request['id_cargo_convocatoria'];
            $usuario = $request['username'];

            $sql = <<<EOD
update rh_dp set id_cargo_convocatoria = '' where id_cargo_convocatoria = $id_cargo_convocatoria
EOD;
            $this->conn->execute($sql);

            $sql = <<<EOD
update no_cargo_convocatoria set estado = 0, fecha_anu = trunc(sysdate), usuario_anu = '$usuario' 
    where id_cargo_convocatoria = $id_cargo_convocatoria and estado = 1
EOD;
            $this->conn->execute($sql);

            /*
             * commit todas las transacciones
             */
            $this->conn->commit();

            $records = array();
            $this->status = 0;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = $records;
            $this->logMessage("[no_cargo_convocatoria] Anulado Exitoso");
        } catch (Exception $exp) {


            //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
            $this->conn->rollback();

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($exp->getMessage());
        }
    }
}
